!==============================================================================
!==============================================================================
!
!     SURFACE GENERATOR
!
!==============================================================================
!==============================================================================

program surface_generator
implicit none

integer nx,ny,nz,nnode,nnodemax,nelem,nelem_surf,real_nnode,nnode_surf
integer inode,ielem,i1,ij,k,i,j,i2,i3,ie,ip,jnode,itr,iitrii
integer ntr1,ntr2,ntr3,ntr4,ntr5,ntr6,iface,surf_id

integer, dimension(:), allocatable :: effect_num
integer,dimension(:,:),allocatable::icon
integer,dimension(:,:),allocatable::icon_surf
integer,dimension(:,:),allocatable::iconf1
integer,dimension(:,:),allocatable::iconf2
integer,dimension(:,:),allocatable::iconf3
integer,dimension(:,:),allocatable::iconf4
integer,dimension(:,:),allocatable::iconf5
integer,dimension(:,:),allocatable::iconf6
integer,dimension(:),allocatable::face
integer,dimension(:),allocatable:: connect1
integer,dimension(:),allocatable:: connect2
integer,dimension(:),allocatable:: connect3
integer,dimension(:),allocatable:: connect4
integer,dimension(:),allocatable:: connect5
integer,dimension(:),allocatable:: connect6

double precision x0,y0,z0
double precision x1,y1,z1
double precision x2,y2,z2
double precision x3,y3,z3
double precision xne,yne,zne,x123,y123,z123
double precision xl,yl,zl
double precision dz,w,pi,wx,wy,dist,xyzn
double precision,dimension(:),allocatable::x,y,z,xn,yn,zn,noise,x_surf,y_surf,z_surf,x_surfn,y_surfn,z_surfn
double precision,dimension(:),allocatable::xf1,yf1,zf1
double precision,dimension(:),allocatable::xf2,yf2,zf2
double precision,dimension(:),allocatable::xf3,yf3,zf3
double precision,dimension(:),allocatable::xf4,yf4,zf4
double precision,dimension(:),allocatable::xf5,yf5,zf5
double precision,dimension(:),allocatable::xf6,yf6,zf6
double precision,dimension(:),allocatable::tempbuffer
double precision,dimension(:),allocatable::xn_surf,yn_surf,zn_surf

logical flag1,flag2,flag3,flag4,flag5,flag6,test,debug
logical, dimension(:), allocatable :: include_point 
character :: nb

pi=atan(1.d0)*4.d0

!==============================================================================
!=====[user inputs]============================================================
!==============================================================================

!debug=.true.
!debug=.false.
!x0=0.d0
!y0=0.2d0
!z0=0.d0
!xl=0.8d0
!yl=0.8d0
!zl=0.111d0
!nx=32
!ny=32
!nz=9
!flag1=.false.
!flag1=.true.
!flag2=.false.
!flag2=.true.
!flag3=.false.
!flag3=.true.
!flag4=.false.
!flag4=.true.
!flag5=.false.
!flag5=.true.
!flag6=.false.
!flag6=.true.

open (unit=12345,file='input.surf',status='old')
read(12345,*) i  ; debug=(i==1)
read(12345,*) x0
read(12345,*) y0
read(12345,*) z0
read(12345,*) xl
read(12345,*) yl
read(12345,*) zl
read(12345,*) nx
read(12345,*) ny
read(12345,*) nz
read(12345,*) i  ; flag1=(i==1)
read(12345,*) i  ; flag2=(i==1)
read(12345,*) i  ; flag3=(i==1)
read(12345,*) i  ; flag4=(i==1)
read(12345,*) i  ; flag5=(i==1)
read(12345,*) i  ; flag6=(i==1)
read(12345,*) surf_id
close(123456)


 


!==============================================================================
!==============================================================================
!==============================================================================

write(*,'(a,f20.15)') 'x0=',x0
write(*,'(a,f20.15)') 'y0=',y0
write(*,'(a,f20.15)') 'z0=',z0
write(*,'(a,f20.15)') 'xl=',xl
write(*,'(a,f20.15)') 'yl=',yl
write(*,'(a,f20.15)') 'zl=',zl
write(*,'(a,i5)')     'nx=',nx
write(*,'(a,i5)')     'ny=',ny
write(*,'(a,i5)')     'nz=',nz

!==============================================================================
!==============================================================================

nnode = nx*ny*2 + (nz-2)*nx*2 + (nz-2)*(ny-2)*2
nelem = ((nx-1)*(ny-1)*2 + (nx-1)*(nz-1)*2 + (ny-1)*(nz-1)*2)*2
nnodemax = (nx*ny + nx*nz + ny*nz)*2

print *,'nnodemax =',nnodemax
print *,'nnode    =',nnode
print *,'nelem    =',nelem

allocate(x(nnodemax))
allocate(y(nnodemax))
allocate(z(nnodemax))

allocate(connect1(ny*nz))
allocate(xf1(ny*nz))
allocate(yf1(ny*nz))
allocate(zf1(ny*nz))
allocate(connect2(ny*nz))
allocate(xf2(ny*nz))
allocate(yf2(ny*nz))
allocate(zf2(ny*nz))
allocate(connect3(nx*nz))
allocate(xf3(nx*nz))
allocate(yf3(nx*nz))
allocate(zf3(nx*nz))
allocate(connect4(nx*nz))
allocate(xf4(nx*nz))
allocate(yf4(nx*nz))
allocate(zf4(nx*nz))
allocate(connect5(nx*ny))
allocate(xf5(nx*ny))
allocate(yf5(nx*ny))
allocate(zf5(nx*ny))
allocate(connect6(nx*ny))
allocate(xf6(nx*ny))
allocate(yf6(nx*ny))
allocate(zf6(nx*ny))

allocate(face(nelem))

!==============================================================================
!=====[place points in space]==================================================
!==============================================================================

inode=0

!=====[x=x0]=====[face1]=======================================================

jnode=0
do j=1,ny
   do k=1,nz
      inode=inode+1
      jnode=jnode+1
      x(inode)=x0
      y(inode)=y0+yl*dble(j-1)/dble(ny-1)
      z(inode)=z0+zl*dble(k-1)/dble(nz-1)
      connect1(jnode)=inode
      xf1(jnode)=x0
      yf1(jnode)=y0+yl*dble(j-1)/dble(ny-1)
      zf1(jnode)=z0+zl*dble(k-1)/dble(nz-1)
   enddo
enddo

!=====[x=x0+xl]=====[face2]====================================================

jnode=0
do j=1,ny
   do k=1,nz
      inode=inode+1
      jnode=jnode+1
      x(inode)=x0+xl
      y(inode)=y0+yl*dble(j-1)/dble(ny-1)
      z(inode)=z0+zl*dble(k-1)/dble(nz-1)
      connect2(jnode)=inode
      xf2(jnode)=x0+xl
      yf2(jnode)=y0+yl*dble(j-1)/dble(ny-1)
      zf2(jnode)=z0+zl*dble(k-1)/dble(nz-1)
   enddo
enddo

!=====[y=y0]=====[face3]=======================================================

jnode=0
do i=1,nx
   do k=1,nz
      inode=inode+1
      jnode=jnode+1
      x(inode)=x0+xl*dble(i-1)/dble(nx-1)
      y(inode)=y0
      z(inode)=z0+zl*dble(k-1)/dble(nz-1)
      connect3(jnode)=inode
      xf3(jnode)=x0+xl*dble(i-1)/dble(nx-1)
      yf3(jnode)=y0
      zf3(jnode)=z0+zl*dble(k-1)/dble(nz-1)
   enddo
enddo

!=====[y=y0+yl]=====[face4]====================================================

jnode=0
do i=1,nx
   do k=1,nz
      inode=inode+1
      jnode=jnode+1
      x(inode)=x0+xl*dble(i-1)/dble(nx-1)
      y(inode)=y0+yl
      z(inode)=z0+zl*dble(k-1)/dble(nz-1)
      connect4(jnode)=inode
      xf4(jnode)=x0+xl*dble(i-1)/dble(nx-1)
      yf4(jnode)=y0+yl
      zf4(jnode)=z0+zl*dble(k-1)/dble(nz-1)
   enddo
enddo

!=====[z=z0]=====[face5]=======================================================

jnode=0
do i=1,nx
   do j=1,ny
      inode=inode+1
      jnode=jnode+1
      x(inode)=x0+xl*dble(i-1)/dble(nx-1)
      y(inode)=y0+yl*dble(j-1)/dble(ny-1)
      z(inode)=z0
      connect5(jnode)=inode
      xf5(jnode)=x0+xl*dble(i-1)/dble(nx-1)
      yf5(jnode)=y0+yl*dble(j-1)/dble(ny-1)
      zf5(jnode)=z0
   enddo
enddo

!=====[z=z0+zl]=====[face6]====================================================

jnode=0
do i=1,nx
   do j=1,ny
      inode=inode+1
      jnode=jnode+1
      x(inode)=x0+xl*dble(i-1)/dble(nx-1)
      y(inode)=y0+yl*dble(j-1)/dble(ny-1)
      z(inode)=z0+zl
      connect6(jnode)=inode
      xf6(jnode)=x0+xl*dble(i-1)/dble(nx-1)
      yf6(jnode)=y0+yl*dble(j-1)/dble(ny-1)
      zf6(jnode)=z0+zl
   enddo
enddo

if (inode/=nnodemax) write(*,'(a,i6)') 'pb: nb of created points',inode, ' and nnode=',nnode

write(*,'(a,3f20.15)') 'min(x),max(x)',minval(x),maxval(x),x0+xl
write(*,'(a,3f20.15)') 'min(y),max(y)',minval(y),maxval(y),y0+yl
write(*,'(a,3f20.15)') 'min(z),max(z)',minval(z),maxval(z),z0+zl

!=====[output points]==========================================================
 
if (debug) then
   open( unit=1234 , file='ptcles1.dat', status='replace')
   do ip=1,nnodemax
      write(1234,'(3f30.15)') x(ip),y(ip),z(ip)
   end do
   close(1234)
end if

!==============================================================================
!=====[triangulate each face separately in local numerotation]=================
!==============================================================================

ntr1=2*(ny-1)*(nz-1)
ntr2=2*(ny-1)*(nz-1)
ntr3=2*(nx-1)*(nz-1)
ntr4=2*(nx-1)*(nz-1)
ntr5=2*(nx-1)*(ny-1)
ntr6=2*(nx-1)*(ny-1)

allocate(iconf1(3,ntr1))
allocate(iconf2(3,ntr2))
allocate(iconf3(3,ntr3))
allocate(iconf4(3,ntr4))
allocate(iconf5(3,ntr5))
allocate(iconf6(3,ntr6))

iitrii=0

!=====[face1]===================================================================

itr=0
do k=1,nz-1
do j=1,ny-1
   itr=itr+1
   iitrii=iitrii+1
   face(iitrii)=1
   iconf1(2,itr)=(j-1)*nz+k
   iconf1(1,itr)=j*nz+k
   iconf1(3,itr)=j*nz+k+1
   itr=itr+1
   iitrii=iitrii+1
   face(iitrii)=1
   iconf1(2,itr)=(j-1)*nz+k
   iconf1(1,itr)=j*nz+k+1
   iconf1(3,itr)=(j-1)*nz+k+1
end do
end do

!=====[face2]==================================================================

itr=0
do k=1,nz-1
do j=1,ny-1
   itr=itr+1
   iitrii=iitrii+1
   face(iitrii)=2
   iconf2(1,itr)=(j-1)*nz+k
   iconf2(2,itr)=j*nz+k
   iconf2(3,itr)=j*nz+k+1
   itr=itr+1
   iitrii=iitrii+1
   face(iitrii)=2
   iconf2(1,itr)=(j-1)*nz+k
   iconf2(2,itr)=j*nz+k+1
   iconf2(3,itr)=(j-1)*nz+k+1
end do
end do

!=====[face3]==================================================================

itr=0
do k=1,nz-1
do j=1,nx-1
   itr=itr+1
   iitrii=iitrii+1
   face(iitrii)=3
   iconf3(1,itr)=(j-1)*nz+k
   iconf3(2,itr)=j*nz+k
   iconf3(3,itr)=j*nz+k+1
   itr=itr+1
   iitrii=iitrii+1
   face(iitrii)=3
   iconf3(1,itr)=(j-1)*nz+k
   iconf3(2,itr)=j*nz+k+1
   iconf3(3,itr)=(j-1)*nz+k+1
end do
end do

!=====[face4]==================================================================

itr=0
do k=1,nz-1
do j=1,nx-1
   itr=itr+1
   iitrii=iitrii+1
   face(iitrii)=4
   iconf4(2,itr)=(j-1)*nz+k
   iconf4(1,itr)=j*nz+k
   iconf4(3,itr)=j*nz+k+1
   itr=itr+1
   iitrii=iitrii+1
   face(iitrii)=4
   iconf4(2,itr)=(j-1)*nz+k
   iconf4(1,itr)=j*nz+k+1
   iconf4(3,itr)=(j-1)*nz+k+1
end do
end do

!=====[face5]==================================================================

itr=0
do k=1,ny-1
do j=1,nx-1
   itr=itr+1
   iitrii=iitrii+1
   face(iitrii)=5
   iconf5(2,itr)=(j-1)*ny+k
   iconf5(1,itr)=j*ny+k
   iconf5(3,itr)=j*ny+k+1
   itr=itr+1
   iitrii=iitrii+1
   face(iitrii)=5
   iconf5(2,itr)=(j-1)*ny+k
   iconf5(1,itr)=j*ny+k+1
   iconf5(3,itr)=(j-1)*ny+k+1
end do
end do

!=====[face6]==================================================================

itr=0
do k=1,ny-1
do j=1,nx-1
   itr=itr+1
   iitrii=iitrii+1
   face(iitrii)=6
   iconf6(1,itr)=(j-1)*ny+k
   iconf6(2,itr)=j*ny+k
   iconf6(3,itr)=j*ny+k+1
   itr=itr+1
   iitrii=iitrii+1
   face(iitrii)=6
   iconf6(1,itr)=(j-1)*ny+k
   iconf6(2,itr)=j*ny+k+1
   iconf6(3,itr)=(j-1)*ny+k+1
end do
end do

if (iitrii/=nelem) stop 'pb boarf'

if (ntr1 /= count(face==1)) stop 'pb1'
if (ntr2 /= count(face==2)) stop 'pb2'
if (ntr3 /= count(face==3)) stop 'pb3'
if (ntr4 /= count(face==4)) stop 'pb4'
if (ntr5 /= count(face==5)) stop 'pb5'
if (ntr6 /= count(face==6)) stop 'pb6'

if (debug) then
   call output_face (1,ny,nz,xf1,yf1,zf1,ntr1,iconf1)
   call output_face (2,ny,nz,xf2,yf2,zf2,ntr2,iconf2)
   call output_face (3,nx,nz,xf3,yf3,zf3,ntr3,iconf3)
   call output_face (4,nx,nz,xf4,yf4,zf4,ntr4,iconf4)
   call output_face (5,nx,ny,xf5,yf5,zf5,ntr5,iconf5)
   call output_face (6,nx,ny,xf6,yf6,zf6,ntr6,iconf6)
end if

!=====[assembling triangulations]

if (ntr1+ntr2+ntr3+ntr4+ntr5+ntr6 /= nelem) stop 'pb with nb of triangles'

allocate (icon(3,nelem))

itr=0
do i=1,ntr1
   itr=itr+1
   icon(1,itr)=connect1(iconf1(1,i))
   icon(2,itr)=connect1(iconf1(2,i))
   icon(3,itr)=connect1(iconf1(3,i))
end do
do i=1,ntr2
   itr=itr+1
   icon(1,itr)=connect2(iconf2(1,i))
   icon(2,itr)=connect2(iconf2(2,i))
   icon(3,itr)=connect2(iconf2(3,i))
end do
do i=1,ntr3
   itr=itr+1
   icon(1,itr)=connect3(iconf3(1,i))
   icon(2,itr)=connect3(iconf3(2,i))
   icon(3,itr)=connect3(iconf3(3,i))
end do
do i=1,ntr4
   itr=itr+1
   icon(1,itr)=connect4(iconf4(1,i))
   icon(2,itr)=connect4(iconf4(2,i))
   icon(3,itr)=connect4(iconf4(3,i))
end do
do i=1,ntr5
   itr=itr+1
   icon(1,itr)=connect5(iconf5(1,i))
   icon(2,itr)=connect5(iconf5(2,i))
   icon(3,itr)=connect5(iconf5(3,i))
end do
do i=1,ntr6
   itr=itr+1
   icon(1,itr)=connect6(iconf6(1,i))
   icon(2,itr)=connect6(iconf6(2,i))
   icon(3,itr)=connect6(iconf6(3,i))
end do

!=====[output all points (incl redundant ones) and triangles]==================

if (debug) then
   open(unit=30,file='temp_mesh_1.vtk')
   write(30,'(a)')'# vtk DataFile Version 3.0'
   write(30,'(a)')'surface'
   write(30,'(a)')'ASCII'
   write(30,'(a)')'DATASET UNSTRUCTURED_GRID'
   write(30,'(a7,i10,a6)')'POINTS ',nnodemax,' float'
   do i=1,nnodemax
      write(30,'(3f16.11)') x(i),y(i),z(i)
   enddo
   write(30,'(A6, 2I10)') 'CELLS ',nelem,4*nelem
   do i=1,nelem
      write(30,'(9I10)') 3, icon(1:3,i)-1
   enddo
   write(30,'(A11, I10)') 'CELL_TYPES ',nelem
   do i=1,nelem
      write(30,'(I2)') 5 ! octree  (8 nodes)
   enddo
   close(30)
end if


!==============================================================================
!=====[remove redundant points]================================================
!==============================================================================

i1=1

111 continue

do i=i1,nnodemax
   do j=i+1,nnodemax
      dist=(x(i)-x(j))**2+(y(i)-y(j))**2+(z(i)-z(j))**2
      if (dist.lt.1.d-10) then
         do ij=j+1,nnodemax
            x(ij-1)=x(ij)
            y(ij-1)=y(ij)
            z(ij-1)=z(ij)
         enddo
         do ij=1,nelem
            do k=1,3
               if (icon(k,ij).eq.j) icon(k,ij)=i
            enddo
         enddo
         do ij=1,nelem
            do k=1,3
               if (icon(k,ij).gt.j) icon(k,ij)=icon(k,ij)-1
            enddo
         enddo
         nnodemax=nnodemax-1
         i1=i
         goto 111
      endif
   enddo
enddo

if (nnodemax/=nnode) stop 'pb with nb of points' 

!====[resize x,y,z to correct nb of points]====================================

allocate(tempbuffer(nnode))

tempbuffer=x(1:nnode)
deallocate(x)
allocate(x(nnode))
x=tempbuffer

tempbuffer=y(1:nnode)
deallocate(y)
allocate(y(nnode))
y=tempbuffer

tempbuffer=z(1:nnode)
deallocate(z)
allocate(z(nnode))
z=tempbuffer

deallocate(tempbuffer)

!====[output all points (without redundant ones) and triangles ]===============

if (debug) then
   open(unit=30,file='temp_mesh_2.vtk')
   write(30,'(a)')'# vtk DataFile Version 3.0'
   write(30,'(a)')'surface'
   write(30,'(a)')'ASCII'
   write(30,'(a)')'DATASET UNSTRUCTURED_GRID'
   write(30,'(a7,i10,a6)')'POINTS ',nnode,' float'
   do i=1,nnode
      write(30,'(3f16.11)') x(i),y(i),z(i)
   enddo
   write(30,'(A6, 2I10)') 'CELLS ',nelem,4*nelem
   do i=1,nelem
      write(30,'(9I10)') 3, icon(1:3,i)-1
   enddo
   write(30,'(A11, I10)') 'CELL_TYPES ',nelem
   do i=1,nelem
      write(30,'(I2)') 5 ! octree  (8 nodes)
   enddo
   close(30)
end if

!=====[compute normals]========================================================

allocate(xn(nnode))
allocate(yn(nnode))
allocate(zn(nnode))

xn=0.d0
yn=0.d0
zn=0.d0
do i=1,nelem
   i1=icon(1,i)
   i2=icon(2,i)
   i3=icon(3,i)
   if (i1.eq.i2 .and. i2.eq.i3) print*,'element ',i,' collapsed: ',icon(:,i)
   x1=x(i1)
   x2=x(i2)
   x3=x(i3)
   y1=y(i1)
   y2=y(i2)
   y3=y(i3)
   z1=z(i1)
   z2=z(i2)
   z3=z(i3)
   xne=(y2-y1)*(z3-z1)-(y3-y1)*(z2-z1)
   yne=(z2-z1)*(x3-x1)-(z3-z1)*(x2-x1)
   zne=(x2-x1)*(y3-y1)-(x3-x1)*(y2-y1)
   xyzn=sqrt(xne**2+yne**2+zne**2)
   xne=xne/xyzn
   yne=yne/xyzn
   zne=zne/xyzn
   do j=1,3
      ij=icon(j,i)
      xn(ij)=xn(ij)+xne
      yn(ij)=yn(ij)+yne
      zn(ij)=zn(ij)+zne
   enddo
enddo
do i=1,nnode
   xyzn=sqrt(xn(i)**2+yn(i)**2+zn(i)**2)
   xn(i)=xn(i)/xyzn
   yn(i)=yn(i)/xyzn
   zn(i)=zn(i)/xyzn
enddo

!=====[output points, triangles, and normals in vtk file]======================

if (debug) then
open(unit=30,file='mesh.vtk')
write(30,'(a)')'# vtk DataFile Version 3.0'
write(30,'(a)')'surface'
write(30,'(a)')'ASCII'
write(30,'(a)')'DATASET UNSTRUCTURED_GRID'
write(30,'(a7,i10,a6)')'POINTS ',nnode,' float'
do i=1,nnode
   write(30,'(3f16.11)') x(i),y(i),z(i)
enddo
write(30,'(A6, 2I10)') 'CELLS ',nelem,4*nelem
do i=1,nelem
   write(30,'(9I10)') 3, icon(1:3,i)-1
enddo
write(30,'(A11, I10)') 'CELL_TYPES ',nelem
do i=1,nelem
   write(30,'(I2)') 5 ! octree  (8 nodes)
enddo
write(30,'(a11,i10)')'POINT_DATA ',nnode
write(30,'(a)')'VECTORS norm float'
do i=1,nnode
   write(30,'(3f18.13)') xn(i),yn(i),zn(i)
enddo
close(30)
end if

!==============================================================================
!=====[only keeping desired points and triangles]==============================
!==============================================================================

allocate(include_point(nnode))

include_point=.false.

do i=1,nelem
   iface=face(i)
   if ((iface==1 .and. flag1) .or. &
       (iface==2 .and. flag2) .or. &
       (iface==3 .and. flag3) .or. &
       (iface==4 .and. flag4) .or. &
       (iface==5 .and. flag5) .or. &
       (iface==6 .and. flag6 )) then
      i1=icon(1,i)
      i2=icon(2,i)
      i3=icon(3,i)
      include_point(i1)=.true.
      include_point(i2)=.true.
      include_point(i3)=.true.
   end if
end do

nnode_surf=count(include_point)
print *,'nb of surface points ',nnode_surf

nelem_surf = 0
if (flag1) nelem_surf=nelem_surf+count(face==1)
if (flag2) nelem_surf=nelem_surf+count(face==2)
if (flag3) nelem_surf=nelem_surf+count(face==3)
if (flag4) nelem_surf=nelem_surf+count(face==4)
if (flag5) nelem_surf=nelem_surf+count(face==5)
if (flag6) nelem_surf=nelem_surf+count(face==6)

print *,'nb of surface triangles ',nelem_surf

!================================================


allocate(x_surf(nnode_surf))
allocate(y_surf(nnode_surf))
allocate(z_surf(nnode_surf))

ie=0
do i=1,nnode
   if (include_point(i)) then
      ie=ie+1
      x_surf(ie)=x(i)
      y_surf(ie)=y(i)
      z_surf(ie)=z(i)
   end if
end do
if (ie/=nnode_surf) stop 'pb niouf' 


allocate (effect_num(nnode))
ie=0
do i=1,nnode
   if (include_point(i)) then 
      ie=ie+1
      effect_num(i)=ie
   end if
end do


allocate(icon_surf(3,nelem_surf))

test=.false.

ie=0
do i=1,nelem
   iface=face(i)
   if ((iface==1 .and. flag1) .or. &
       (iface==2 .and. flag2) .or. &
       (iface==3 .and. flag3) .or. &
       (iface==4 .and. flag4) .or. &
       (iface==5 .and. flag5) .or. &
       (iface==6 .and. flag6 )) then

      ie=ie+1
      icon_surf(1,ie)=effect_num(icon(1,i))
      icon_surf(2,ie)=effect_num(icon(2,i))
      icon_surf(3,ie)=effect_num(icon(3,i))

   end if

end do

if (ie/=nelem_surf) stop 'pb arf'

!=====[output temporory mesh of surface]=======================================

if (debug) then
   open(unit=30,file='temp_mesh_3.vtk')
   write(30,'(a)')'# vtk DataFile Version 3.0'
   write(30,'(a)')'surface'
   write(30,'(a)')'ASCII'
   write(30,'(a)')'DATASET UNSTRUCTURED_GRID'
   write(30,'(a7,i10,a6)')'POINTS ',nnode_surf,' float'
   do i=1,nnode_surf
      write(30,'(3f16.11)') x_surf(i),y_surf(i),z_surf(i)
   enddo
   write(30,'(A6, 2I10)') 'CELLS ',nelem_surf,4*nelem_surf
   do i=1,nelem_surf
      write(30,'(9I10)') 3, icon_surf(1:3,i)-1
   enddo
   write(30,'(A11, I10)') 'CELL_TYPES ',nelem_surf
   do i=1,nelem_surf
      write(30,'(I2)') 5 ! octree  (8 nodes)
   enddo
   close(30)
end if

!=====[compute normals of surface]=============================================

allocate(xn_surf(nnode_surf))
allocate(yn_surf(nnode_surf))
allocate(zn_surf(nnode_surf))

xn_surf=0.d0
yn_surf=0.d0
zn_surf=0.d0
do i=1,nelem_surf
   i1=icon_surf(1,i)
   i2=icon_surf(2,i)
   i3=icon_surf(3,i)
   if (i1.eq.i2 .and. i2.eq.i3) print*,'element ',i,' collapsed: ',icon(:,i)
   x1=x_surf(i1)
   x2=x_surf(i2)
   x3=x_surf(i3)
   y1=y_surf(i1)
   y2=y_surf(i2)
   y3=y_surf(i3)
   z1=z_surf(i1)
   z2=z_surf(i2)
   z3=z_surf(i3)
   xne=(y2-y1)*(z3-z1)-(y3-y1)*(z2-z1)
   yne=(z2-z1)*(x3-x1)-(z3-z1)*(x2-x1)
   zne=(x2-x1)*(y3-y1)-(x3-x1)*(y2-y1)
   xyzn=sqrt(xne**2+yne**2+zne**2)
   xne=xne/xyzn
   yne=yne/xyzn
   zne=zne/xyzn
   do j=1,3
      ij=icon_surf(j,i)
      xn_surf(ij)=xn_surf(ij)+xne
      yn_surf(ij)=yn_surf(ij)+yne
      zn_surf(ij)=zn_surf(ij)+zne
   enddo
enddo
do i=1,nnode_surf
   xyzn=sqrt(xn_surf(i)**2+yn_surf(i)**2+zn_surf(i)**2)
   xn_surf(i)=xn_surf(i)/xyzn
   yn_surf(i)=yn_surf(i)/xyzn
   zn_surf(i)=zn_surf(i)/xyzn
end do

!=====[output vtk file of surface]=============================================

write(nb,'(i1)') surf_id

open(unit=30,file='surface_sg_'//nb//'.vtk')
write(30,'(a)')'# vtk DataFile Version 3.0'
write(30,'(a)')'surface'
write(30,'(a)')'ASCII'
write(30,'(a)')'DATASET UNSTRUCTURED_GRID'
write(30,'(a7,i10,a6)')'POINTS ',nnode_surf,' float'
do i=1,nnode_surf
   write(30,'(3f16.11)') x_surf(i),y_surf(i),z_surf(i)
enddo
write(30,'(A6, 2I10)') 'CELLS ',nelem_surf,4*nelem_surf
do i=1,nelem_surf
   write(30,'(9I10)') 3, icon_surf(1:3,i)-1
enddo
write(30,'(A11, I10)') 'CELL_TYPES ',nelem_surf
do i=1,nelem_surf
   write(30,'(I2)') 5 ! octree  (8 nodes)
enddo
write(30,'(a11,i10)')'POINT_DATA ',nnode_surf
write(30,'(a)')'VECTORS norm float'
do i=1,nnode_surf
   write(30,'(3f18.13)') xn_surf(i),yn_surf(i),zn_surf(i)
enddo
close(30)

!==============================================================================
!=====[produce data file readable by DOUAR]====================================
!==============================================================================

write(nb,'(i1)') surf_id

open (71,file='surface-'//nb//'.txt',status='unknown')
write (71,*) nnode_surf,nelem_surf

do i=1,nnode_surf
   write (71,*) x_surf(i),y_surf(i),z_surf(i),xn_surf(i),yn_surf(i),zn_surf(i)
enddo

do i=1,nelem_surf
   write (71,*) (icon_surf(j,i),j=1,3)
enddo

close (71)

end program surface_generator


!==============================================================================
!==============================================================================
!==============================================================================
!==============================================================================
!==============================================================================
!==============================================================================



subroutine output_face (iface,n1,n2,xf,yf,zf,ntr,icon)
implicit none
integer iface,n1,n2,ntr
integer icon(3,ntr)
double precision xf(n1*n2)
double precision yf(n1*n2)
double precision zf(n1*n2)

integer i
character :: nb

write(nb,'(i1)') iface

open(unit=30,file='face_'//nb//'.vtk')
write(30,'(a)')'# vtk DataFile Version 3.0'
write(30,'(a)')'surface'
write(30,'(a)')'ASCII'
write(30,'(a)')'DATASET UNSTRUCTURED_GRID'
write(30,'(a7,i10,a6)')'POINTS ',n1*n2,' float'

do i=1,n1*n2
   write(30,'(3f16.11)') xf(i),yf(i),zf(i)
enddo

write(30,'(A6, 2I10)') 'CELLS ',ntr,4*ntr

do i=1,ntr
   write(30,'(9I10)') 3, icon(1:3,i)-1
enddo

write(30,'(A11, I10)') 'CELL_TYPES ',ntr

do i=1,ntr
   write(30,'(I2)') 5 ! octree  (8 nodes)
 enddo

!      write(30,'(a11,i10)')'POINT_DATA ',real_nnode
!      write(30,'(a)')'VECTORS norm float'
!      do i=1,nnode
!         if (yesno_point(i)) write(30,'(3f18.13)')xn(i),yn(i),zn(i)
!      enddo
!      do i=1,real_nnode
!         write(30,'(3f18.13)') x_surfn(i),y_surfn(i),z_surfn(i)
!      enddo
close(30)

return
end subroutine output_face



